IxcRegistry

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.dvb.io.ixc
Class IxcRegistry

    java.lang.Object
      org.dvb.io.ixc.IxcRegistry

    public class IxcRegistry

extends Object

This is the bootstrap mechanism for obtaining references to remote objects residing in other Xlets executing on the same MHP terminal, using a URL-like syntax. The identification of a remote object is given using a syntax indicating the organisation ID and application ID:
/organisation_id/application_id/name
organisation_id = the organisation ID of the Xlet, as signalled in the application_identifier record, defined in the MHP specification.
application_id = the application ID of the Xlet, as signalled in the application_identifier record, defined in the MHP specification.
name = the name under which the remote object was exported.

The organisation ID and the application ID shall each be encoded as a hexadecimal string, as would be accepted by java.lang.Integer.parseInt(String s, 16).

When RMI is used to communicate over a network, stubs generated by a tool like rmic are often required. This is not necessary for inter-xlet communication initiated with IxcRegistry. If such stubs are present, they shall be ignored.

Similarly, network RMI objects often extend the class server.RemoteObject, in order to get appropriate implementations for Object.hashCode(), Object.equals(), and Object.toString(). Overriding Object's implementation of these methods in this way is not necessary for inter-xlet communication initiated with IxcRegistry, although it is not harmful. Note that the class server.RemoteObject is not required in all MHP profiles.

Method Summary
`static void` | `bind(XletContext xc, String name, Remote obj)` Exports an object under a given name in the namespace of an Xlet.
`static String[]` | `list(XletContext xc)` Returns an array of string path objects available in the registry.
`static Remote` | `lookup(XletContext xc, String path)` Returns a remote object previously exported by an Xlet that has not been destroyed.
`static void` | `rebind(XletContext xc, String name, Remote obj)` Rebind the name to a new object in the context of an Xlet; replaces any existing binding.
`static void` | `unbind(XletContext xc, String name)` Unbind the name.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### lookup

    public static Remote lookup(XletContext xc,
                                String path)
                         throws NotBoundException,
                                RemoteException

  Returns a remote object previously exported by an Xlet that has not been destroyed. The identification of a remote object is given using a syntax indicating the organisation ID and application ID:
  /organisation_id/application_id/name
  organisation_id = the organisation ID of the Xlet, as signalled in the application_identifier record.
  application_id = the application ID of the Xlet, as signalled in the application_identifier record.
  name = the name under which the remote object was exported.

  The organisation ID and the application ID shall each be encoded as a hexadecimal string, as would be accepted by java.lang.Integer.parseInt(String s, 16). If the caller is not authorized to import a given object due to the security policy, then this API will behave as though the object had not been exported, that is, a NotBoundException shall be thrown.

  Parameters:
    `xc` - The context of the current Xlet (that is, the Xlet importing the object).
    `path` - A file pathname-like string identifying the Xlet and the name of the object to be imported.
  Returns:
    A remote object
  Throws:
    `NotBoundException` - If the path is not currently bound.
    `RemoteException` - If a remote stub class cannot be generated for the object being imported.
    `IllegalArgumentException` - If the path is not formatted in the syntax given above.
    `NullPointerException` - if path is null

### bind

    public static void bind(XletContext xc,
                            String name,
                            Remote obj)
                     throws AlreadyBoundException

  Exports an object under a given name in the namespace of an Xlet. The name can be any valid non-null String. No hierarchical namespace exists, e.g. the names "foo" and "bar/../foo" are distinct. If the exporting xlet has been destroyed, this method may fail silently.

  Parameters:
    `xc` - The context of the Xlet exporting the object.
    `name` - The name identifying the object.
    `obj` - The object being exported
  Throws:
    `AlreadyBoundException` - if this Xlet has previously exported an object under the given name.
    `NullPointerException` - if xc, name or obj is null

### unbind

    public static void unbind(XletContext xc,
                              String name)
                       throws NotBoundException

  Unbind the name.

  Parameters:
    `xc` - The context of the Xlet that exported the object to be unbound.
    `name` - The name identifying the object.
  Throws:
    `NotBoundException` - if this is not currently any object exported by this Xlet under the given name.
    `NullPointerException` - if xc or name is null

### rebind

    public static void rebind(XletContext xc,
                              String name,
                              Remote obj)

  Rebind the name to a new object in the context of an Xlet; replaces any existing binding. The name can be any valid non-null String. No hierarchical namespace exists, e.g. the names "foo" and "bar/../foo" are distinct. If the exporting xlet has been destroyed, this method may fail silently.

  Parameters:
    `xc` - The context of the Xlet that exported the object.
    `name` - The name identifying the object.
    `obj` - The object being exported
  Throws:
    `NullPointerException` - if xc, name or obj is null

### list

    public static String[] list(XletContext xc)

  Returns an array of string path objects available in the registry. The array contains a snapshot of the names present in the registry that the current Xlet would be allowed to import using IxcRegistry.lookup.

  Parameters:
    `xc` - The context of the current Xlet.
  Returns:
    A non-null array of strings containing a snapshot of the path names of all objects available to the caller in this registry.
  See Also:
    `lookup(javax.tv.xlet.XletContext,String)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD